//+------------------------------------------------------------------+
//|                                           Square of Range v3.mq4 |
//|                                         Copyright  2009, Kharko |
//|                                         9 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Kharko"
#property link      ""

#property indicator_chart_window

extern int Complect=0;
extern int timeframe=0;    
extern bool angle=true;   // / 
extern bool fan=false;     //  
extern bool SQ9=false;     // /      9
extern bool square=false;  //      
extern int range_time=144; //  
extern int move_time=0;    //         
extern int move_price=0;   //         
extern double scale_time=1;//   
extern double scale_price=1;//   
extern int shift_txt=35;   //  ,  
extern double  result_price=10000;//     
extern int  quantity_figures=5;//    
extern bool over=false;    

extern bool backgr=false;
extern bool stopper=false;
extern bool save=false;

extern color point_col=Blue;
extern color vlines_col=Blue;
extern color hlines_col=Blue;
extern color colour1=FireBrick;
extern color colour2=Green;
extern color colour3=Blue;

extern int vlines_style=0;
extern int hlines_style=0;
extern int style1=0;

extern int point_width=1;
extern int vlines_width=1;
extern int hlines_width=1;
extern int width1=1;

extern bool handycode=false;
extern int code=108;

extern bool delpoints=false;

datetime prevtime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   fDelete();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(delpoints)
    {
     ObjectDelete(StringConcatenate("Sq.Range.Point1 Complect",Complect));
     ObjectDelete(StringConcatenate("Sq.Range.Point2 Complect",Complect));
    }
    fDelete();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int error=GetLastError();
//----
   if(stopper)
    {
     if(prevtime == Time[0]) return(0);
     if(error!=4066) prevtime = Time[0];
    }
//----
   int P,nP1,nP2,nH,nL,nPoint;
   int pointcode,time1;
   double period,pH,pL,range,tmp;
   bool up;
   datetime Date1, Date2;
   string freeze="";
   if(save) freeze=" saved";
//----    
   if(vlines_style<0 || vlines_style>4) vlines_style=0;
   if(hlines_style<0 || hlines_style>4) hlines_style=0;
   if(style1<0 || style1>4) style1=0;
//----   
   fDelete();
//----
   switch (timeframe)
    {
      case 1:
         period = OBJ_PERIOD_M1;
         break;
      case 5:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5; else period = OBJ_PERIOD_M5;
         break;
      case 15:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15; else period = OBJ_PERIOD_M15;
         break;
      case 30:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30; else period = OBJ_PERIOD_M30;
         break;      
      case 60:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1; else period = OBJ_PERIOD_H1;
         break;
      case 240:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4; else period = OBJ_PERIOD_H4;
         break;
      case 1440:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1; else period = OBJ_PERIOD_D1;
         break;
      case 10080:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1 | OBJ_PERIOD_W1; else period = OBJ_PERIOD_W1;
         break;
      case 43200:
         period = OBJ_PERIOD_MN1;
         break;
      case 0:
         period = NULL;
         break;
      case -1:
         period = EMPTY;
         break;       
    }   
//---- 
   if(handycode) pointcode=code;
   else
    {
     switch (Complect)
      {
       case  0: pointcode = 139; break;
       case  1: pointcode = 140; break;
       case  2: pointcode = 141; break;
       case  3: pointcode = 142; break;
       case  4: pointcode = 143; break;
       case  5: pointcode = 144; break;
       case  6: pointcode = 145; break;
       case  7: pointcode = 146; break;
       case  8: pointcode = 147; break;
       case  9: pointcode = 148; break;
       case 10: pointcode = 149; break;
       case 11: pointcode = 128; break;
       case 12: pointcode = 129; break;
       case 13: pointcode = 130; break;
       case 14: pointcode = 131; break;
       case 15: pointcode = 132; break;
       case 16: pointcode = 133; break;
       case 17: pointcode = 134; break;
       case 18: pointcode = 135; break;
       case 19: pointcode = 136; break;
       case 20: pointcode = 137; break;
       case 21: pointcode = 138; break;
       default: pointcode = code;
      }
    }        
//----
   string str=StringConcatenate("Sq.Range.Point1 Complect",Complect);
   if(ObjectFind(str)!=0) ObjectCreate(str, OBJ_ARROW, 0, Time[35], (High[35]+Low[35])/2);
   ObjectSet(str,OBJPROP_ARROWCODE,pointcode);
   ObjectSet(str,OBJPROP_COLOR,point_col);
   ObjectSet(str,OBJPROP_WIDTH,point_width);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
   Date1=ObjectGet(str,OBJPROP_TIME1);
//----   
   str=StringConcatenate("Sq.Range.Point2 Complect",Complect);
   if(ObjectFind(str)!=0) ObjectCreate(str, OBJ_ARROW, 0, Time[1], (High[1]+Low[1])/2);
   ObjectSet(str,OBJPROP_ARROWCODE,pointcode);
   ObjectSet(str,OBJPROP_COLOR,point_col);
   ObjectSet(str,OBJPROP_WIDTH,point_width);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
   Date2=ObjectGet(str,OBJPROP_TIME1);   
//----  
   nP1=iBarShift(NULL,0,Date1,false);
   nP2=iBarShift(NULL,0,Date2,false);
   if(nP1>nP2)
    {
     P=nP1;
     nP1=nP2;
     nP2=P;
    }
   nH=iHighest(NULL,0,MODE_HIGH,nP2-nP1+1,nP1);
   nL=iLowest(NULL,0,MODE_LOW,nP2-nP1+1,nP1);
   pH=High[nH];
   pL=Low[nL];
   range=(pH-pL)/Point;
   if(!square)
   {
      range_time=MathAbs(nH-nL);
      Comment("\nSpeed (pips/bar) = ",DoubleToStr(range/range_time,2));
   }
   else
      Comment("");
   if(nL>nH) up=true;
   else if(nL<nH) up=false;  
   if(SQ9)
   {
      double res_pr;
      if(up)
      {
         res_pr=NormalizeDouble(pL*result_price,0);
         str=DoubleToStr(res_pr,0);
         if(StringLen(str)>quantity_figures)
            res_pr=StrToDouble(StringSubstr(str,StringLen(str)-quantity_figures,quantity_figures));
         range=(MathPow(MathSqrt(8*res_pr)+2,2)/8-res_pr)/Point/result_price;
//         Print(range," ",res_pr);
         
      }
      else
      {
         res_pr=NormalizeDouble(pH*result_price,0);
         str=DoubleToStr(res_pr,0);
         if(StringLen(str)>quantity_figures)
            res_pr=StrToDouble(StringSubstr(str,StringLen(str)-quantity_figures,quantity_figures));
         range=(res_pr-MathPow(MathSqrt(8*res_pr)-2,2)/8)/Point/result_price;
//         Print(range," ",res_pr);
      }
   }
   if(up)
     nPoint=nH-scale_time*move_time*range_time;
   else
     nPoint=nL-scale_time*move_time*range_time;
   pH+=scale_price*move_price*range*Point;
   pL+=scale_price*move_price*range*Point;

//----
if(!fan)
{
//----
   str=StringConcatenate("Sq.Range.VL 0/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
      if(nPoint>=0) ObjectCreate(str,OBJ_VLINE,0,Time[nPoint],1.0);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-nPoint*Period()*60,1.00);
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 1/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 2/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-scale_time*range_time/4,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 3/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-3*scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 4/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-4*scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 5/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-5*scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 6/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-6*scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 7/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-7*scale_time*range_time/8,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 8/8 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-scale_time*range_time,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,vlines_col);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 1/3 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-scale_time*range_time/3,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,colour2);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----     
   str=StringConcatenate("Sq.Range.VL 2/3 Complect",Complect,freeze);
   if(ObjectFind(str)!=0)
   {
      time1=NormalizeDouble(nPoint-2*scale_time*range_time/3,0);
      if(time1>=0) ObjectCreate(str,OBJ_VLINE,0,Time[time1],1.00);
      else ObjectCreate(str,OBJ_VLINE,0,Time[0]-time1*Period()*60,1.00);
   }
   ObjectSet(str,OBJPROP_COLOR,colour2);
   ObjectSet(str,OBJPROP_STYLE,vlines_style);
   ObjectSet(str,OBJPROP_WIDTH,vlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
}
//----
   if(up)
   {
//----
      if(!fan)
      {
//----
     str=StringConcatenate("Sq.Range.HL 8/8 Complect",Complect,freeze);
     tmp=pL;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 8/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str,DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 7/8 Complect",Complect,freeze);
     tmp=pL+scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 7/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 6/8 Complect",Complect,freeze);
     tmp=pL+2*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 6/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 5/8 Complect",Complect,freeze);
     tmp=pL+3*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 5/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 4/8 Complect",Complect,freeze);
     tmp=pL+4*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 4/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 3/8 Complect",Complect,freeze);
     tmp=pL+5*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 3/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 2/8 Complect",Complect,freeze);
     tmp=pL+6*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 2/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 1/8 Complect",Complect,freeze);
     tmp=pL+7*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 1/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 0/8 Complect",Complect,freeze);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 0/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 2/3 Complect",Complect,freeze);
     tmp=pL+scale_price*range*Point/3;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 2/3 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", colour2);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 1/3 Complect",Complect,freeze);
     tmp=pL+2*scale_price*range*Point/3;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 1/3 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", colour2);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     if(angle)
     {
     str=StringConcatenate("Sq.Range.CrossLine+ 1/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pL);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pL);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 2/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/2,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pL);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pL);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 1/2 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point/2;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
//----      
     str=StringConcatenate("Sq.Range.CrossLine+ 1/4 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+3*scale_price*range*Point/4;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 4/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/4,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pL);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pL);
         }
     }
//----      
     str=StringConcatenate("Sq.Range.CrossLine+ 1/8 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+7*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL+scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 8/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/8,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pL);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pL);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pL);
         }
     }
     }
     }
//----      
     if(angle)
     {
     str=StringConcatenate("Sq.Range.CrossLine 1/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 2/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/2,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 1/2 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point/2;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
//----      
     str=StringConcatenate("Sq.Range.CrossLine 1/4 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point/4;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 4/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/4,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----      
     str=StringConcatenate("Sq.Range.CrossLine 1/8 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pL+scale_price*range*Point/8;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 8/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/8,0);
     tmp=pL+scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pL,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pL,Time[0]-time1*Period()*60,tmp);
         }
     }
     }
   }
//----    
   else
   {
     if(!fan)
     {
     str=StringConcatenate("Sq.Range.HL 8/8 Complect",Complect,freeze);
     tmp=pH;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 8/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 7/8 Complect",Complect,freeze);
     tmp=pH-scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 7/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 6/8 Complect",Complect,freeze);
     tmp=pH-2*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 6/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 5/8 Complect",Complect,freeze);
     tmp=pH-3*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 5/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 4/8 Complect",Complect,freeze);
     tmp=pH-4*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 4/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 3/8 Complect",Complect,freeze);
     tmp=pH-5*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 3/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 2/8 Complect",Complect,freeze);
     tmp=pH-6*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 2/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 1/8 Complect",Complect,freeze);
     tmp=pH-7*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 1/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 0/8 Complect",Complect,freeze);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 0/8 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", hlines_col);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 2/3 Complect",Complect,freeze);
     tmp=pH-scale_price*range*Point/3;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 2/3 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", colour2);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     str=StringConcatenate("Sq.Range.HL 1/3 Complect",Complect,freeze);
     tmp=pH-2*scale_price*range*Point/3;
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0],tmp);
     str=StringConcatenate("Sq.Range.HL.txt 1/3 Complect",Complect,freeze);
     if(ObjectFind(str)!=0)     
     ObjectCreate(str,OBJ_TEXT,0,Time[shift_txt],tmp);
     ObjectSetText(str, DoubleToStr(tmp,Digits), 8, "Arial", colour2);
     ObjectSet(str,OBJPROP_BACK,backgr);
     ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----      
     if(angle)
     {
     str=StringConcatenate("Sq.Range.CrossLine+ 1/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pH);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pH);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 2/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/2,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pH);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pH);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 1/2 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point/2;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 4/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/4,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pH);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pH);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 1/4 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-3*scale_price*range*Point/4;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 8/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/8,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[time1],pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[time1],pH);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],tmp,Time[0]-time1*Period()*60,pH);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,tmp,Time[0]-time1*Period()*60,pH);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine+ 1/8 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-7*scale_price*range*Point/8;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH-scale_price*range*Point,Time[0]-time1*Period()*60,tmp);
         }
     }
     }
     }
//----      
     if(angle)
     {
     str=StringConcatenate("Sq.Range.CrossLine 1/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 2/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/2,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 1/2 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point/2;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
//----     
     str=StringConcatenate("Sq.Range.CrossLine 4/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/4,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 1/4 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point/4;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 8/1 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time/8,0);
     tmp=pH-scale_price*range*Point;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
//----     
     str=StringConcatenate("Sq.Range.CrossLine 1/8 Complect",Complect,freeze);
     time1=NormalizeDouble(nPoint-scale_time*range_time,0);
     tmp=pH-scale_price*range*Point/8;
     if(ObjectFind(str)!=0)
     {
         if(time1>=0) 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[time1],tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[time1],tmp);
         }
         else 
         {
            if(nPoint>=0) 
               ObjectCreate(str,OBJ_TREND,0,Time[nPoint],pH,Time[0]-time1*Period()*60,tmp);
            else
               ObjectCreate(str,OBJ_TREND,0,Time[0]-nPoint*Period()*60,pH,Time[0]-time1*Period()*60,tmp);
         }
     }
     }
   }                 
//----
   str=StringConcatenate("Sq.Range.HL 0/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 1/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 2/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 3/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 4/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 5/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 6/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 7/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 8/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,hlines_col);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 1/3 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour2);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----
   str=StringConcatenate("Sq.Range.HL 2/3 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour2);
   ObjectSet(str,OBJPROP_STYLE,hlines_style);
   ObjectSet(str,OBJPROP_WIDTH,hlines_width);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 1/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 1/2 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 2/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//if(!fan && square)
{
//----   
   str=StringConcatenate("Sq.Range.CrossLine 1/4 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 4/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 1/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine 8/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 1/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 1/2 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 2/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour1);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 1/4 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 4/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 1/8 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
//----   
   str=StringConcatenate("Sq.Range.CrossLine+ 8/1 Complect",Complect,freeze);
   ObjectSet(str,OBJPROP_COLOR,colour3);
   ObjectSet(str,OBJPROP_STYLE,style1);
   ObjectSet(str,OBJPROP_WIDTH,width1);
   ObjectSet(str,OBJPROP_BACK,backgr);
   ObjectSet(str,OBJPROP_TIMEFRAMES,period);
}
//----
   return(0);
  }
//+------------------------------------------------------------------+
int fDelete()
  {
//----
   ObjectDelete(StringConcatenate("Sq.Range.VL 0/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 1/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 2/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 3/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 4/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 5/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 6/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 7/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 8/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 1/3 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.VL 2/3 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 0/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 1/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 2/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 3/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 4/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 5/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 6/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 7/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 8/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 1/3 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL 2/3 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 1/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 2/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 1/2 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 4/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 1/4 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 8/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine 1/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 1/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 2/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 1/2 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 4/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 1/4 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 8/1 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.CrossLine+ 1/8 Complect",Complect));

   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 0/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 1/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 2/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 3/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 4/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 5/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 6/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 7/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 8/8 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 1/3 Complect",Complect));
   ObjectDelete(StringConcatenate("Sq.Range.HL.txt 2/3 Complect",Complect));
   return(0);
  }
//+------------------------------------------------------------------+

